/*$Id: d_ccvs.cc,v 14.19 1999/08/18 17:17:11 al Exp $ -*- C++ -*-
 * functions for ccvs
 * It is really voltage controlled, taking into account the sense element.
 * Then adjust the gain to account for the sense element.
 */
#include "d_ccvs.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_CCVS::expand();
// 	bool	DEV_CCVS::do_tr();
// 	void	DEV_CCVS::do_ac();
/*--------------------------------------------------------------------------*/
void DEV_CCVS::expand()
{
  {if (!_input_label.empty()){
    _input = dynamic_cast<ELEMENT*>(find_in_scope(_input_label));
  }else{
    // _input already set, an internal element.  none used yet
    untested();
  }}
  if (!_input){
    untested();
    error(bERROR, long_label() + ": " + _input_label
	  + " cannot be used as current probe\n");
  }
  {if (_input->is_2port()){
    untested();
    n[IN1] = _input->n[IN1];
    n[IN2] = _input->n[IN2];
  }else{
    assert(_input->is_1port()  ||  _input->is_source());
    n[IN1] = _input->n[OUT1];
    n[IN2] = _input->n[OUT2];
  }}
  n[IN1].e = n[IN2].e = INVALIDNODE;
  loss = 1./OPT::shortckt;
  y0.f1 = value();
  y0.f0 = LINEAR;
  m0.c1 = -loss * value();
  m0.c0 = 0.;
  ev = value();
  acg = -loss * value();
  set_converged();
  assert(!constant()); /* because of incomplete analysis */
}
/*--------------------------------------------------------------------------*/
bool DEV_CCVS::do_tr()
{
  assert(!is_bypassed());
  m0.x = n[IN1].v0() - n[IN2].v0();
  y0.x = _input->tr_amps();
  {if (has_tr_eval()){
    tr_eval();
    m0.c0 = y0.f0 - y0.x * y0.f1;
  }else{
    assert(converged());
    y0.f1 = value();
    y0.f0 = y0.x * y0.f1;
    m0.c0 = 0.;
  }}
  m0.c0 += y0.f1 * _input->m0.c0;
  m0.c1  = y0.f1 * (_input->loss + _input->m0.c1);
  m0 *= -loss;
  store_values();
  SIM::loadq.push(this);
  return converged();
}
/*--------------------------------------------------------------------------*/
void DEV_CCVS::do_ac()
{
  if (!_input->evaluated()){
    untested();
    _input->do_ac();	    /* BUG: premature load of sense element */
  }
  ac_load_loss();
  {if (has_ac_eval()){
    untested();
    acbias = n[IN1].vdc() - n[IN2].vdc();
    ac_eval();
  }else{
    ev  = y0.f1;
  }}
  {if (_input->is_source()){
    acg = -loss * ev * _input->acg;
    ac_load_source();
    acg = -loss * ev * _input->loss;
    ac_load_active();
  }else{
    acg = -loss * ev * _input->acg;
    ac_load_active();
  }}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
