/*$Id: d_coil.h,v 14.19 1999/08/18 17:17:11 al Exp $ -*- C++ -*-
 * Inductance (L) component
 */
#ifndef D_COIL_H
#define D_COIL_H
#include "e_storag.h"
/*--------------------------------------------------------------------------*/
class DEV_INDUCTANCE : public STORAGE {
private:
  explicit	DEV_INDUCTANCE(const DEV_INDUCTANCE& p):STORAGE(p){}
public:
  explicit	DEV_INDUCTANCE()	{}
private: // override virtual
  CARD*		clone()const		{return new DEV_INDUCTANCE(*this);}
  bool		do_tr();
  void		tr_load();
  void		tr_unload();
  void		do_ac();
  double	tr_review();
  const char*	dev_type()const		{return "inductor";}
private:
  void		integrate();
};
/*--------------------------------------------------------------------------*/
class DEV_MUTUAL_L : public COMPONENT {
private:
  explicit	DEV_MUTUAL_L(const DEV_MUTUAL_L& p);
public:
  explicit	DEV_MUTUAL_L();
private: // override virtual
  CARD*		clone()const	{untested(); return new DEV_MUTUAL_L(*this);}
  void		parse(CS&);
  void		print(OMSTREAM where, int detail)const;
  void		expand();
  bool		do_tr()			{return true;}
  void		tr_load()		{/*nothing*/}
  void		tr_unload()		{/*nothing*/}
  void		do_ac()			{/*nothing*/}
  double	tr_involts()const
			{untested(); return dn_diff(n[IN1].v0(), n[IN2].v0());}
  COMPLEX	ac_involts()const{untested();return n[IN1].vac()-n[IN2].vac();}
  const char*	dev_type()const		{return "mutual_inductor";}
  bool		is_2port()const		{untested(); return true;}
private:
  std::string	_output_label;
  CARD*		_output;
  std::string	_input_label;
  CARD*		_input;
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
