/*$Id: d_res.cc,v 14.19 1999/08/18 17:17:11 al Exp $ -*- C++ -*-
 * functions for resistor.
 * x = amps, y.f0 = volts, ev = y.f1 = ohms
 */
#include "d_res.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_RESISTANCE::expand();
// 	bool	DEV_RESISTANCE::do_tr();
// 	void	DEV_RESISTANCE::do_ac();
/*--------------------------------------------------------------------------*/
void DEV_RESISTANCE::expand()
{
  {if (value() == 0.){
    if (!has_common()){
      error(bPICKY, long_label() + ": short circuit\n");
    }
    y0.f1 = OPT::shortckt;
  }else{
    y0.f1 = value();
  }}
  y0.f0 = LINEAR;
  m0.c1 = 1./y0.f1;
  m0.c0 = 0.;
  ev    = value();
  acg   = m0.c1;
  assert(loss == 0.);
  set_constant(!has_tr_eval());
}
/*--------------------------------------------------------------------------*/
bool DEV_RESISTANCE::do_tr()
{
  assert(!is_bypassed());
  {if (has_tr_eval()){
    m0.x = volts_limited(n[OUT1],n[OUT2]);
    y0.x = m0.c0 + m0.c1 * m0.x;
    tr_eval();
    if (y0.f1 == 0.){
      untested();
      error(bPICKY, long_label() + ": short circuit\n");
      y0.f1 = OPT::shortckt;
    }
    store_values();
    SIM::loadq.push(this);
    m0.c1 = 1./y0.f1;
    m0.c0 = y0.x - y0.f0 / y0.f1;
  }else{
    untested();
    assert(conchk(m0.c1, 1./y0.f1, OPT::abstol));
    assert(m0.c0 == 0.);
    assert(y1 == y0);
    assert(converged());
  }}
  return converged();
}
/*--------------------------------------------------------------------------*/
void DEV_RESISTANCE::do_ac()
{
  {if (has_ac_eval()){
    double dcvolts = n[OUT1].vdc() - n[OUT2].vdc();
    acbias = m0.c0 + m0.c1*dcvolts;
    ac_eval();
    if (ev == 0.){
      untested();
      error(bPICKY, long_label() + ": short circuit\n");
      ev = OPT::shortckt;
    }
    acg = 1. / ev;
  }else if (has_tr_eval()){
    untested();
    ev  = y0.f1;
    acg = 1. / y0.f1;
  }else{
    //assert(acg == 1./y0.f1);
  }}
  ac_load_passive();
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
